<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Database miscellaneous conditions test Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">Miscellaneous conditions test </H1>
        <h2>Test Objective</h2>
        <P>This is a series of tests that exercises metadataAPI exception handling of the following:
		<UL><pre><font color='brown'>
     dbException:putMetaData:optional group name 1 PASSED
     dbException:putMetaData:optional group name 2 PASSED
     dbException:putMetaData:optional group name 3 PASSED
     dbException:putMetaData:test no group/table name PASSED
     dbException:putMetaData:test no seqid PASSED
     dbException:putMetaData:single set insertion PASSED
     dbException:putMetaData:test double set insertion PASSED
     dbException:putMetaData:bad data in ilwd PASSED
     dbException:putMetaData:skip comments metadata0101 PASSED
     dbException:putMetaData:skip comments comments PASSED
     dbException:getMetaData:notInvalidElement PASSED
     dbException:metadata:putMetaData:invalid data rollback PASSED
     dbException:getMetaData:invalid data rollback validate PASSED
     dbException:metadata:putMetaData:duplicate data rollback PASSED
     dbException:getMetaData:duplicate data rollback validate PASSED
     dbException:dataPipeline:non-standard DSO inspiral error PASSED
     dbException:dataPipeline:non-standard DSO slope error PASSED
     dbException:dataPipeline:non standard DSO inspiral ok PASSED
     dbException:dataPipeline:non standard DSO slope ok PASSED
     dbException:putMetaData:bad database name putMetaData PASSED
     dbException:getMetaData:bad database name getMetaData PASSED
     dbException:getMetaData:uppper case database name getMetaData PASSED
     dbException:putMetaData:uppper case database name putMetaData PASSED
     dbException:dataPipeline:dbquality channel on test database ok PASSED
     dbException:dataPipeline:gaps no database data PASSED
     dbException:putMetaData:ligolw exception from bad xml PASSED
     dbException:getMetaData:frame not supported PASSED
     dbException:getMetaData:invalid ilwd format PASSED
     dbException:getMetaData:getMetaData outputformat default PASSED
     dbException:putMetaData:unknown table PASSED
     dbException:putMetaData:out of range PASSED
     dbException:dataPipeline:Unofficial DSO PASSED
     dbException:putMetaData:database deadlock rollback PASSED
     </pre></font>
		</UL>
		
		<h2>APIs affected by this test</h2>:
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion.
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <ol>
        <li>Using ligotools <p>If ligotools is desired, check that ligotools is mounted:
        <pre>
        ldas:ldas:ldas-dev.ldas-dev:test> df /ligotools
        Filesystem           1K-blocks      Used Available Use% Mounted on
        /dev/dsk/c3t1d0s6    498316151 326700089 171616062  66% /export
        </pre>
        Set up a default ldas account and password via ligotools utility <i>ldaspw</i>. Currently ligotools does not support job submission
        via globus sockets. </li><p> 
        <li>Default is use the LDAS ldasJob package included in installation. Globus socket is supported.
        <li>Test driver <CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/dbException.tcl?rev=HEAD;content-type=text%2Fplain'>dbException.tcl</a></font>
        is found in /ldas/testbin and is part of ldas installation. Supporting generic test scripts are in /ldas/lib/test and /ldas/libexec.
        </li><p>
		The following test data files are part of the installation:
        <pre><font color='brown'>optname1.xml optname2.xml optname3.xml
test_bare_names.xml test_no_seqid.xml file4733_1.xml
try1.xml baddata.xml metadata0101.xml
txn2.ilwd rollback1.ilwd rollback.ilwd
out-of-range.ilwd nulldata.binary.ilwd</pre></font>
		</CODE></LI><p>
				
		</UL>
        </ol>
        <H2>Test Execution</H2>
        <ol>
        <li>Login to site gateway box e.g. dev, as user <b>ldas</b></li>
        <li>cd &lt;your work directory&gt;</li>
		
        <B>Usage:</B> <CODE> <font color='brown'> /ldas/testbin/dbException.tcl [options] >& dbException.log & </font></CODE><p>
        Options described are specific to dbException but when running generic options are included.

        <P><TABLE border=1 cellspacing=0 cellpadding=5>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
			<TR>
                <TD valign=top><CODE>--database</CODE>
                <TD>database name at a site e.g. dev_1 or ldas_tst
        </TABLE><p>e.g. with globus sockets:<pre><font color='brown'>        
   	dbException.tcl --site dev -debug 0 -verbose lpse --enable-globus 1 --enable-gsi 1 
    	--database dev_1 &lt;/dev/null &gt;& dbException.log &</font></pre>
        and with tcl sockets:<pre><font color='brown'>
        dbException.tcl --site dev -debug 0 -verbose lpse --enable-globus 0 --enable-gsi 0 
        --database dev_1 &lt;/dev/null &gt;& dbException.log &</font></pre>
        To enable debugging, set debug level to 1 or greater: <pre><font color='brown'>        
   	dbException.tcl --site dev -debug 1 -verbose lpse --enable-globus 1 --enable-gsi 1 
    	--database dev_1 --qa-debug-level 1 &lt;/dev/null &gt;& dbException.log &</font></pre>
        </li>
        </ol>
		<p>
        <ul>
		<li>At times the database data needs to be cleared out again for subsequent tests. This is done inside the test script.</li>
        <li>For deadlock/rollback a database connection needs to be maintained on the database server
        so a helper script is used to accomplish this:
        <a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/dbException.tcl?rev=HEAD;content-type=text%2Fplain'>rundb2cmds.tcl</a></font><br>
        dbException.tcl directs the execution of db2 commands by rundb2cmds.tcl on the database server host via ssh pipe. </li>
		<p>
		<H2>Test Validation:</H2>
		If all the data has been cleared out successfully, the results obtained for each transaction to ldas should match the
		expected result in the script.
        e.g. <pre><font color='brown'>
            dbException.tcl:        Total   33      Passed  33      Skipped 0       Failed  0</font></pre>
        <p>
    </BODY>
</HTML>

